import math

def sign(x):
    if x < 0:
        return -1
    elif x == 0:
        return 0
    return 1

def bisection(a, b, max_iter, xreal):
    c = (a + b) / 2
    n = 0
    while n < max_iter:
        if sign(f(c)) == 0:
            return c
        elif sign(f(c)) == sign(f(a)):
            a = c
        else:
            b = c
        c = (a + b) / 2

        error = "not defined"
        if xreal is not None:
            error = abs(xreal - c)

        print(f"n: {n}\na: {a}\nb: {b}\nc: {c}\nerror: {error}\n")
        n += 1
    return c

# your function f(x)
def f(x):
    return math.cos(x) - x

# Define your interval [a, b], and the maximum number of iterations
a = 0
b = 1.4
max_iter = 60
xreal = None

# Call the bisection function
result = bisection(a, b, max_iter, xreal)
print("Root found at:", result)
